// DKADlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "DKADlg.h"

#define	__DKADLG__
#include "DllCOM.h"
#undef __DKADLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

// Global variables
char gblSerial[5];
int gblInitCom;
int gblNGrtInstd;	//Number of gratings installed on turret#1
long gblNGrtSelted;	//Number of grating selected.
long gblCurGr, gblCurBl;
float gblCurWL;
CString gblsCurWL;
int gblPortNo;
int gblSSpeed;
int gblType;		//0: single, 1: Additive dispersion, 254: Subtractive dps.
int gblAddr;
int gblS1, gblS2, gblS3;	//S1: Entrance slit, S2: Exit, S3: Middle.
int gblNovAdd29;	//Dk configuration byte.
int gblYesFM;
int gblFilter;
int gblLED;		//0:Off, 1:On
int gblFmPos;	//0:Mono, 1:Spec.

int count;
int in;
int out;
BYTE data[255];

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDKADlg dialog

CDKADlg::CDKADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDKADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDKADlg)
	m_sStaticBlaze = _T("301");
	m_sStaticGroove = _T("1201");
	m_sStaticGrtNum = _T("0");
	m_sStaticSerial = _T("12345");
	m_sEditWL = _T("100.00");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDKADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDKADlg)
	DDX_Text(pDX, IDC_STATICBLAZE, m_sStaticBlaze);
	DDX_Text(pDX, IDC_STATICGROOVE, m_sStaticGroove);
	DDX_Text(pDX, IDC_STATICGRTNUM, m_sStaticGrtNum);
	DDX_Text(pDX, IDC_STATICSERIAL, m_sStaticSerial);
	DDX_Text(pDX, IDC_EDITWL, m_sEditWL);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDKADlg, CDialog)
	//{{AFX_MSG_MAP(CDKADlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BEXIT, OnBexit)
	ON_COMMAND(IDM_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(IDM_COMMANDS_C_ECHO, OnCommandsCEcho)
	ON_COMMAND(IDM_COMMANDS_C_GOTO, OnCommandsCGoto)
	ON_COMMAND(IDM_COMMANDS_C_SCAN, OnCommandsCScan)
	ON_COMMAND(IDM_COMMANDS_C_SPEED, OnCommandsCSpeed)
	ON_COMMAND(IDM_COMMANDS_C_SLITS, OnCommandsCSlits)
	ON_COMMAND(IDM_COMMANDS_C_SELECT, OnCommandsCSelect)
	ON_COMMAND(IDM_COMMANDS_S_ZERO, OnCommandsSZero)
	ON_COMMAND(IDM_COMMANDS_C_RESET, OnCommandsCReset)
	ON_COMMAND(IDM_NOVRAM_READ, OnNovramRead)
	ON_COMMAND(IDM_NOVRAM_WRITE, OnNovramWrite)
	ON_COMMAND(IDM_COMMANDS_S_SLITCAL, OnCommandsSSlitcal)
	ON_COMMAND(IDM_COMPORT_INIT, OnComportInit)
	ON_COMMAND(IDM_COMMANDS_S_CALIBRATE, OnCommandsSCalibrate)
	ON_COMMAND(IDM_COMMANDS_C_FILTER, OnCommandsCFilter)
	ON_COMMAND(IDM_COMMANDS_F_HOME, OnCommandsFHome)
	ON_COMMAND(IDM_COMMANDS_F_FLIP, OnCommandsFFlip)
	ON_COMMAND(IDM_COMMANDS_F_CALIBRATE, OnCommandsFCalibrate)
	ON_COMMAND(IDM_COMMANDS_F_POSITION, OnCommandsFPosition)
	ON_COMMAND(IDM_COMMANDS_F_LED, OnCommandsFLed)
	ON_EN_CHANGE(IDC_EDITWL, OnChangeEditwl)
	ON_COMMAND(IDM_COMMANDS_EXIT, OnBexit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDKADlg message handlers

BOOL CDKADlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_dComDlg.DoModal();
	
	int DkSerB, SlitQ[6];
	BYTE GrtID[6];
	int DataI, SSpeed, FilterN, iLED;
	long lWave;
	InitCOM();

	if(GetDkSerial(&DkSerB))
		return FALSE;
	if(GetGrtID(GrtID))
		return FALSE;
	if(GetWave(&lWave))
		return FALSE;
	if(NovramRd(29, &DataI))
		return FALSE;

	if (DataI & 0x40)
		gblYesFM = 1;
	else
		gblYesFM = 0;


	if(GetSlit(SlitQ))
		return FALSE;
	if(GetSSpeed(&SSpeed))
		return FALSE;
	if(GetFilter(&FilterN))
		return FALSE;
	if (gblYesFM == 1)
	{
		if(GetLED(&iLED))
			return FALSE;
	}
	CloseCOM();
	gblNovAdd29=DataI;
	gblNGrtInstd=GrtID[0];
	gblNGrtSelted=GrtID[1];
	gblCurGr=GrtID[2]*256 + GrtID[3];
	gblCurBl=GrtID[4]*256 + GrtID[5];
	gblCurWL=(float)lWave;
	gblS1=SlitQ[0];
	gblS2=SlitQ[1];
	gblS3=SlitQ[3];
	gblFilter=FilterN;
	gblSSpeed = SSpeed;

	gblLED=iLED;	//0:Off,  1:On.
	gblFmPos=iLED;	//0:Mono, 1:Spec.

	//--------------------------------
	m_sStaticGroove.Format("%d", gblCurGr);
	m_sStaticBlaze.Format("%d", gblCurBl);
	m_sStaticGrtNum.Format("%d", gblNGrtSelted);
	m_sStaticSerial.Format("%d", DkSerB);
	
	gblsCurWL.Format("%10.2f", ((float)gblCurWL/100));		//sWl.Format("%10.1f", (gblCurWL/10));
	m_sEditWL = gblsCurWL;
	// Update dialog
	UpdateData(FALSE);
	//--------------------------------

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDKADlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDKADlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDKADlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDKADlg::OnCommandsCGoto() 
{
	// TODO: Add your command handler code here
	m_dGotoDlg.DoModal();
	m_sEditWL=gblsCurWL;
	// Update the dialog
	UpdateData(FALSE);	
	
}

void CDKADlg::OnCommandsCScan() 
{
	// TODO: Add your command handler code here
	m_dScanDlg.DoModal();
	m_sEditWL=gblsCurWL;
	// Update the dialog
	UpdateData(FALSE);	
}

void CDKADlg::OnCommandsCSpeed() 
{
	// TODO: Add your command handler code here
	m_dSSpeedDlg.DoModal();
}

void CDKADlg::OnCommandsCSlits() 
{
	// TODO: Add your command handler code here
	m_dSlitAdjDlg.DoModal();

}

void CDKADlg::OnCommandsCSelect() 
{
	// TODO: Add your command handler code here
	m_dGrtSelDlg.DoModal();

	BYTE GrtID[6]; 
	int SlitQ[6];
	int SSpeed;
	long lWave;
	InitCOM();
	GetGrtID( GrtID );
	GetWave( &lWave );
	GetSlit( SlitQ );
	GetSSpeed( &SSpeed );
	CloseCOM();

	gblNGrtInstd=GrtID[0];
	gblNGrtSelted=GrtID[1];
	gblCurGr=GrtID[2]*256 + GrtID[3];
	gblCurBl=GrtID[4]*256 + GrtID[5];

//	gblCurWL=lWave;

	gblS1=SlitQ[0]*256+SlitQ[1];
	gblS2=SlitQ[2]*256+SlitQ[3];
	gblS3=SlitQ[4]*256+SlitQ[5];

	gblSSpeed = SSpeed;

	//--------------------------------
	m_sStaticGroove.Format("%d", gblCurGr);
	m_sStaticBlaze.Format("%d", gblCurBl);
	m_sStaticGrtNum.Format("%d", gblNGrtSelted);
	m_sEditWL=gblsCurWL;
	// Update dialog
	UpdateData(FALSE);
	//--------------------------------
	
}


void CDKADlg::OnCommandsCEcho() 
{
	// TODO: Add your command handler code here

	m_dEchoDlg.DoModal();
}


void CDKADlg::OnCommandsCReset() 
{
	// TODO: Add your command handler code here

	m_dResetDlg.DoModal();
	long lWave;	
	InitCOM();
	GetWave( &lWave );
	CloseCOM();
	gblCurWL=(float)lWave;

	gblsCurWL.Format("%10.2f", ((float)gblCurWL/100));		//sWl.Format("%10.1f", (gblCurWL/10));
	m_sEditWL = gblsCurWL;
	// Update dialog
	UpdateData(FALSE);
}


void CDKADlg::OnCommandsSCalibrate() 
{
	// TODO: Add your command handler code here

	m_dCalDlg.DoModal();

}

void CDKADlg::OnCommandsSSlitcal() 
{
	// TODO: Add your command handler code here

	m_dSlitCalDlg.DoModal();	
}


void CDKADlg::OnCommandsSZero() 
{
	// TODO: Add your command handler code here
	m_dZeroDlg.DoModal();
	long lWave;	
	InitCOM();
	GetWave( &lWave );
	CloseCOM();
	gblCurWL=(float)lWave;

	gblsCurWL.Format("%10.2f", ((float)gblCurWL/100));		//sWl.Format("%10.1f", (gblCurWL/10));
	m_sEditWL = gblsCurWL;
	// Update dialog
	UpdateData(FALSE);
}


void CDKADlg::OnBexit() 
{
	// TODO: Add your control notification handler code here

	OnOK();
}


void CDKADlg::OnNovramRead() 
{
	// TODO: Add your command handler code here
	//Write to dialog
	//m_dNovramRdDlg.m_lNovramRdTOut = 10;
	m_dNovramRdDlg.DoModal();
}


void CDKADlg::OnNovramWrite() 
{
	// TODO: Add your command handler code here

	m_dNWrDlg.DoModal();

}


void CDKADlg::OnComportInit() 
{
	// TODO: Add your command handler code here

	m_dComDlg.DoModal();

}


void CDKADlg::OnHelpAbout() 
{
	// TODO: Add your command handler code here

	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}


void CDKADlg::InitCOM()
{
	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When using openCOM()!!!", MB_OK);

}

void CDKADlg::CloseCOM()
{
	closeCOM();
}


int CDKADlg::GetDkSerial(int *DkSerial)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred.
	BYTE StatusB, CancelB;
	char DkA[5];
	BYTE StatusCancel[2];
	int serialI, iRtn;
	iRtn=0;

	*DkSerial = 0;
	iRtn=DKSerialQ(2, StatusCancel, DkA);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	
	char *pDkSerB;
	pDkSerB=DkA;
	serialI=atoi(pDkSerB);
	*DkSerial = serialI;
	return iRtn;
}


int CDKADlg::GetGrtID(BYTE GrtID[6])
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred.
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn;
	iRtn=0;

	iRtn=DKGrtIdQ(2, StatusCancel, GrtID);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	
	return iRtn;
}


int CDKADlg::GetWave(long *lWave)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred.
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn;
	*lWave=20;

	iRtn=DKWaveQ(2, StatusCancel, lWave);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	
	return iRtn;
}

int CDKADlg::GetLED(int *iLED)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred.
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn;
	*iLED=20;
	//DKFmQ(int iTimeout, BYTE *bReturn, int *iFmQ);
	iRtn=DKFmQ(2, StatusCancel, iLED);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	return iRtn;
}


int CDKADlg::NovramRd(int AddrI, int *DataI)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred.	
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn;
	long lData;

	//DKNovramRd(int iTimeout, BYTE *bReturn, long *lData, int iAddr);
	iRtn=DKNovramRd(2, StatusCancel, &lData, AddrI);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	*DataI = (int)lData;
	return iRtn;	//No error = 0; error=1
}


int CDKADlg::GetSlit(int SlitQ[])
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	BYTE StatusCancel[2];
	int Dk242, iRtn, iTimeout;	//0: Dk240, 2: Dk242
	iRtn=0;	//No error = 0; error=1

	iTimeout = 5;		//2s

	Dk242=(gblNovAdd29 & 0x2);
	if(Dk242)
	{
		//DKSlit242Q(int iTimeout, BYTE *bReturn, int *iS1Data, int *iS2Data, int *iS3Data);
		iRtn=DKSlit242Q(iTimeout, StatusCancel, &SlitQ[0], &SlitQ[2], &SlitQ[4]);
	}
	else
	{
		iRtn=DKSlit240Q(iTimeout, StatusCancel, &SlitQ[0], &SlitQ[1]);
	}
	return iRtn;
}

int CDKADlg::GetSSpeed(int *SSpeed)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn;
	long lSSpeed;
	
	iRtn=DKSSpeedQ(2, StatusCancel, &lSSpeed);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];
	*SSpeed = (int)lSSpeed;
	
	return iRtn;
}

void CDKADlg::OnCommandsCFilter() 
{
	// TODO: Add your command handler code here

	m_dFilterDlg.DoModal();
}

int CDKADlg::GetFilter(int *iFilter)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred
	int iData, iRtn;
	BYTE StatusCancel[2];
	//DKMemoryRd(int iTimeout, BYTE *bReturn, int *iData, long lAddr);
	iRtn=DKMemoryRd( 2, StatusCancel, &iData, (long) 33175);
	*iFilter = iData;
	return iRtn;
}

void CDKADlg::OnCommandsFHome() 
{
	// TODO: Add your command handler code here
	
	m_dFmHomeDlg.DoModal();

}

void CDKADlg::OnCommandsFFlip() 
{
	// TODO: Add your command handler code here

	m_dFlipDlg.DoModal();	
}

void CDKADlg::OnCommandsFCalibrate() 
{
	// TODO: Add your command handler code here
	m_dFmCalDlg.DoModal();	
}

void CDKADlg::OnCommandsFPosition() 
{
	// TODO: Add your command handler code here
	m_dFmQDlg.DoModal();	
}

void CDKADlg::OnCommandsFLed() 
{
	// TODO: Add your command handler code here
	m_dFmLEDDlg.DoModal();
}

void CDKADlg::OnChangeEditwl() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here

	m_dGotoDlg.DoModal();
	m_sEditWL=gblsCurWL;
	//Update the dialog
	UpdateData(FALSE);	
}
