// EchoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "EchoDlg.h"

#include <time.h>

#define	__ECHODLG__
#include "DllCOM.h"
#undef __ECHODLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEchoDlg dialog

extern int gblPortNo;



CEchoDlg::CEchoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEchoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEchoDlg)
	m_BEchoByte = 0;
	m_lEchoTOut = 0;
	//}}AFX_DATA_INIT
}


void CEchoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEchoDlg)
	DDX_Text(pDX, IDC_ECHOBYTE, m_BEchoByte);
	DDX_Text(pDX, IDC_ECHOTOUT, m_lEchoTOut);
	DDV_MinMaxLong(pDX, m_lEchoTOut, 0, 3599);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEchoDlg, CDialog)
	//{{AFX_MSG_MAP(CEchoDlg)
	ON_BN_CLICKED(IDC_ECHO, OnEcho)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEchoDlg message handlers


BOOL CEchoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_lEchoTOut=2;	// Initialize to 2s.
	m_BEchoByte=0;
	// Update the dialog
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CEchoDlg::OnEcho() 
{
	// TODO: Add your control notification handler code here
	// VB use time 2s
	// iRtn: 0: no error; 1: Not 27; 128: Not communicated.
	int iRtn, Timeout;

	UpdateData(TRUE);
	Timeout=m_lEchoTOut;		//2s

	iRtn = DKEcho(Timeout);

	switch(iRtn)
	{
		case 0:
			m_BEchoByte = 27;
			break;
		case 1:
			m_BEchoByte = 1;
			break;
		case 128:
			m_BEchoByte = 128;
			break;
		default:
			m_BEchoByte = 99;
			break;
	}
	// Update the dialog
	UpdateData(FALSE);	

}

void CEchoDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();
	CDialog::OnCancel();
}
