// FilterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "FilterDlg.h"

#define	__FILTERDLG__
#include "DllCOM.h"
#undef __FILTERDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg dialog

extern int gblPortNo;
extern int gblFilter;


CFilterDlg::CFilterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFilterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFilterDlg)
	m_iFilterCancel = 0;
	m_iFilterStatus = 0;
	m_lFilterTOut = 0;
	m_iNewFilter = 0;
	//}}AFX_DATA_INIT
}


void CFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilterDlg)
	DDX_Control(pDX, IDOK, m_cOK);
	DDX_Text(pDX, IDC_FILTERCANCEL, m_iFilterCancel);
	DDX_Text(pDX, IDC_FILTERSTATUS, m_iFilterStatus);
	DDX_Text(pDX, IDC_FILTERTOUT, m_lFilterTOut);

	DDX_Text(pDX, IDC_NEWFILTER, m_iNewFilter);
	DDV_MinMaxInt(pDX, m_iNewFilter, 1, 6);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFilterDlg, CDialog)
	//{{AFX_MSG_MAP(CFilterDlg)
	ON_EN_CHANGE(IDC_NEWFILTER, OnChangeNewfilter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg message handlers


BOOL CFilterDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_lFilterTOut=5;	// Initialize to 100s.
	m_iNewFilter=gblFilter;
	m_iFilterCancel=0;
	m_iFilterStatus=0;

	// FALSE: Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CFilterDlg::OnOK() 
{
	// TODO: Add extra validation here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	int iFilter;
	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lFilterTOut;
	iFilter = m_iNewFilter;
	
	iRtn=DKFilter(iTimeout, StatusCancel, iFilter);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iFilterStatus=StatusB;
	m_iFilterCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		gblFilter = iFilter;
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblFilter = iFilter;
	}
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}

}


void CFilterDlg::OnChangeNewfilter() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here

	int NFilter;
	// Update variables
		UpdateData(TRUE);
	NFilter=m_iNewFilter;
	if(NFilter<0)
		m_iNewFilter=1;
	if(6<NFilter)
		m_iNewFilter=6;

		// Update dialog
		UpdateData(FALSE);
}

void CFilterDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
