// GotoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "GotoDlg.h"

#define	__GOTODLG__
#include "DllCOM.h"
#undef __GOTODLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGotoDlg dialog

extern int gblPortNo;
extern float gblCurWL;
extern CString gblsCurWL;

CGotoDlg::CGotoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGotoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGotoDlg)
	m_iStatus = 0;
	m_iCancel = 0;
	m_iGotoCancel = 0;
	m_iGotoStatus = 0;
	m_lGotoTOut = 2;
	m_sGotoWL = _T("");
	//}}AFX_DATA_INIT
}


void CGotoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGotoDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_GOTOCANCEL, m_iGotoCancel);
	DDX_Text(pDX, IDC_GOTOSTATUS, m_iGotoStatus);
	DDX_Text(pDX, IDC_GOTOTOUT, m_lGotoTOut);
	DDV_MinMaxLong(pDX, m_lGotoTOut, 0, 3599);
	DDX_Text(pDX, IDC_GOTOWL, m_sGotoWL);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGotoDlg, CDialog)
	//{{AFX_MSG_MAP(CGotoDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGotoDlg message handlers


BOOL CGotoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);
	
	m_lGotoTOut=100;	// Initialize to 100s.
	m_sGotoWL=gblsCurWL;
	m_iGotoStatus = 0;
	m_iGotoCancel = 0;

	// FALSE: Update the dialog
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGotoDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lWavelength;
	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lGotoTOut;
	lWavelength	= (long)(atof(m_sGotoWL)*100);

	iRtn=DKGoto(iTimeout*4, StatusCancel, lWavelength);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iGotoStatus=StatusB;
	m_iGotoCancel=CancelB;

	m_cOK.EnableWindow(FALSE);
	m_cExit.EnableWindow(FALSE);

	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		gblCurWL = (float)atof(m_sGotoWL);
		gblsCurWL.Format("%10.2f", (float)gblCurWL);
		m_sGotoWL = gblsCurWL;
		// TRUE: Update the variable
		UpdateData(FALSE);
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblCurWL = (float)atof(m_sGotoWL);
	}
	
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
	m_cExit.EnableWindow(TRUE);
}

void CGotoDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}

