// GrtSelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "GrtSelDlg.h"

#define	__GRTSELDLG__
#include "DllCOM.h"
#undef __GRTSELDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGrtSelDlg dialog

extern int gblPortNo;
extern long gblNGrtSelted;

CGrtSelDlg::CGrtSelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrtSelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGrtSelDlg)
	m_iGrtSelCancel = 0;
	m_iGrtSelNew = 0;
	m_iGrtSelStatus = 0;
	m_lGrtSelTOut = 200;
	//}}AFX_DATA_INIT
}


void CGrtSelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGrtSelDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_GRTSELCANCEL, m_iGrtSelCancel);
	DDX_Text(pDX, IDC_GRTSELNEW, m_iGrtSelNew);
	DDX_Text(pDX, IDC_GRTSELSTATUS, m_iGrtSelStatus);
	DDX_Text(pDX, IDC_GRTSELTOUT, m_lGrtSelTOut);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGrtSelDlg, CDialog)
	//{{AFX_MSG_MAP(CGrtSelDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGrtSelDlg message handlers


BOOL CGrtSelDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_iGrtSelStatus=0;
	m_iGrtSelCancel=0;
	m_iGrtSelNew = gblNGrtSelted;
	// Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CGrtSelDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	int iGrt;
	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lGrtSelTOut;
	iGrt = m_iGrtSelNew;
	//DKGrtSel(int iTimeout, BYTE *bReturn, int iGrtB);
	iRtn=DKGrtSel(iTimeout, StatusCancel, iGrt);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iGrtSelStatus=StatusB;
	m_iGrtSelCancel=CancelB;
	m_cOK.EnableWindow(FALSE);
	m_cExit.EnableWindow(FALSE);
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		gblNGrtSelted = iGrt;
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblNGrtSelted = iGrt;
	}
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
	m_cExit.EnableWindow(TRUE);
	
}

void CGrtSelDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
