// NWrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "NWrDlg.h"

#define	__NWRDLG__
#include "DllCOM.h"
#undef __NWRDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNWrDlg dialog

extern int gblPortNo;


CNWrDlg::CNWrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNWrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNWrDlg)
	m_iNWrAddress = 38;
	m_iNWrCancel = 0;
	m_iNWrData = 0;
	m_sNWrDataHex = _T("0");
	m_iNWrStatus = 0;
	m_lNWrTOut = 2;
	//}}AFX_DATA_INIT
}


void CNWrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNWrDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_NWRADDRESS, m_iNWrAddress);
	DDV_MinMaxInt(pDX, m_iNWrAddress, 1, 64);
	DDX_Text(pDX, IDC_NWRCANCEL, m_iNWrCancel);
	DDX_Text(pDX, IDC_NWRDATA, m_iNWrData);
	DDV_MinMaxInt(pDX, m_iNWrData, 0, 65535);
	DDX_Text(pDX, IDC_NWRDATAHEX, m_sNWrDataHex);
	DDX_Text(pDX, IDC_NWRSTATUS, m_iNWrStatus);
	DDX_Text(pDX, IDC_NWRTOUT, m_lNWrTOut);
	DDV_MinMaxLong(pDX, m_lNWrTOut, 0, 3599);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNWrDlg, CDialog)
	//{{AFX_MSG_MAP(CNWrDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	ON_EN_CHANGE(IDC_NWRDATA, OnChangeNwrdata)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNWrDlg message handlers




BOOL CNWrDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_iNWrStatus=0; 
	m_iNWrCancel=0;
	// FALSE: Update the dialog
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CNWrDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	int iAddr;
	long lData;
	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lNWrTOut;
	iAddr = m_iNWrAddress;
	lData = m_iNWrData;
	//DKNovramWr(int iTimeout, BYTE *bReturn, long lData, int iAddr);
	iRtn=DKNovramWr(iTimeout, StatusCancel, lData, iAddr);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iNWrStatus=StatusB;
	m_iNWrCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		m_iNWrData=lData;
		m_sNWrDataHex.Format("%04X", lData);
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
		{
			m_iNWrData=lData;
			m_sNWrDataHex.Format("%04X", lData);
		}
	}
	// Update dialog
	UpdateData(FALSE);
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);

}


void CNWrDlg::OnChangeNwrdata() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	long lData;	
		// FALSE, Update dialog
	UpdateData(TRUE);
	lData = m_iNWrData;

	m_sNWrDataHex.Format("%04X", lData);
	// FALSE, Update dialog
	UpdateData(FALSE);

}

void CNWrDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
