// ResetDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "ResetDlg.h"

#define	__RESETDLG__
#include "DllCOM.h"
#undef __RESETDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CResetDlg dialog

extern int gblPortNo;
extern float gblCurWL;
extern CString gblsCurWL;


CResetDlg::CResetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResetDlg)
	//}}AFX_DATA_INIT
}


void CResetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResetDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Control(pDX, IDC_PROGRESS1, m_cProgress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CResetDlg, CDialog)
	//{{AFX_MSG_MAP(CResetDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResetDlg message handlers


BOOL CResetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_cProgress.SetRange(0,10);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CResetDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	int iRtn, iTimeout, i;

	iTimeout=5;
	//SetDlgItemText(IDC_RESETTING,"RESETTING...");
	m_cOK.EnableWindow(FALSE);
	m_cExit.EnableWindow(FALSE);
	m_cProgress.SetPos(1);	// Clear the progress bar

	//DKReset(int iTimeout)
	DKReset(iTimeout);

	i=0;
	do
	{
		spSleep(iTimeout*1000);
		m_cProgress.SetPos(i+1);
		++i;
		if(i>10) i=0;
		iRtn=DKEcho(2);
	}
	while(iRtn != 0);
	m_cProgress.SetPos(10);

	DKFlushRcv(2);

	m_cOK.EnableWindow(TRUE);
	m_cExit.EnableWindow(TRUE);
}


void CResetDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
