// FmFlipDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "FmFlipDlg.h"

#define	__FMFLIPDLG__
#include "DllCOM.h"
#undef __FMFLIPDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFmFlipDlg dialog

extern int gblPortNo;
extern int gblLED;		//0:Off,  1:On
extern int gblFmPos;	//0:Mono, 1:Spec.


CFmFlipDlg::CFmFlipDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFmFlipDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFmFlipDlg)
	m_iFlipMono = -1;
	//}}AFX_DATA_INIT
}


void CFmFlipDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFmFlipDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Radio(pDX, IDC_FLIPMONO, m_iFlipMono);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFmFlipDlg, CDialog)
	//{{AFX_MSG_MAP(CFmFlipDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFmFlipDlg message handlers

BOOL CFmFlipDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_iFlipMono = gblFmPos;
	// FASLE Update the dialog
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFmFlipDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	int iPos;
	iTimeout=5;
	// FASLE Update the dialog
	UpdateData(TRUE);
	m_cOK.EnableWindow(FALSE);
	m_cExit.EnableWindow(FALSE);
	iPos=m_iFlipMono;
	//DKFmFlip(int iTimeout, BYTE *bReturn, int iFlipB);
	iRtn=DKFmFlip(iTimeout, StatusCancel, iPos);	
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	if (StatusB<=127)
	{
		gblFmPos = iPos;
		gblLED = iPos;
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblFmPos = iPos;
			gblLED = iPos;
	}
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
	m_cExit.EnableWindow(TRUE);
}

void CFmFlipDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
