// FmHomeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "FmHomeDlg.h"

#define	__FMHOMEDLG__
#include "DllCOM.h"
#undef __FMHOMEDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFmHomeDlg dialog

extern int gblPortNo;
extern int gblLED;		//0:Off,  1:On
extern int gblFmPos;	//0:Mono, 1:Spec.


CFmHomeDlg::CFmHomeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFmHomeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFmHomeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CFmHomeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFmHomeDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Control(pDX, IDC_PROGRESS1, m_cProgress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFmHomeDlg, CDialog)
	//{{AFX_MSG_MAP(CFmHomeDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFmHomeDlg message handlers

BOOL CFmHomeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_cProgress.SetRange(0,10);	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFmHomeDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	int iRtn, iTimeout, i;
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];

	iTimeout=5;
	m_cOK.EnableWindow(FALSE);
	m_cExit.EnableWindow(FALSE);
	m_cProgress.SetPos(1);	// Clear the progress bar

	//DKFmHome(int iTimeout, BYTE *bReturn);
	DKFmHome(iTimeout, StatusCancel);
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	i=0;
	do
	{
		spSleep(iTimeout*100);
		m_cProgress.SetPos(i+1);
		++i;
		if(i>10) i=0;
		iRtn=DKEcho(2);
	}
	while(iRtn != 0);
	m_cProgress.SetPos(10);

	DKFlushRcv(2);

	m_cOK.EnableWindow(TRUE);
	m_cExit.EnableWindow(TRUE);
}

void CFmHomeDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
