// FmLEDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "FmLEDDlg.h"

#define	__FMLEDDLG__
#include "DllCOM.h"
#undef __FMLEDDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFmLEDDlg dialog

extern int gblPortNo;
extern int gblLED;		//0:Off, 1:On

CFmLEDDlg::CFmLEDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFmLEDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFmLEDDlg)
	m_iLED1 = -1;
	//}}AFX_DATA_INIT
}


void CFmLEDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFmLEDDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Radio(pDX, IDC_LED1, m_iLED1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFmLEDDlg, CDialog)
	//{{AFX_MSG_MAP(CFmLEDDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFmLEDDlg message handlers

BOOL CFmLEDDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_iLED1 = gblLED;
	// FASLE Update the dialog
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CFmLEDDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	int iLED;
	iTimeout=2;
	// FASLE Update the dialog
	UpdateData(TRUE);
	iLED=m_iLED1;
	iRtn=DKFmLED(iTimeout, StatusCancel, iLED);	
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	if (StatusB<=127)
	{
		gblLED = iLED;
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblLED = iLED;
	}
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
}

void CFmLEDDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
