// FmQDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "FmQDlg.h"

#define	__FMQDLG__
#include "DllCOM.h"
#undef __FMQDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFmQDlg dialog

extern int gblPortNo;
extern int gblLED;		//0:Off, 1:On
extern int gblFmPos;	//0:Mono, 1:Spec.


CFmQDlg::CFmQDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFmQDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFmQDlg)
	m_iPosMono = -1;
	//}}AFX_DATA_INIT
}


void CFmQDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFmQDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Radio(pDX, IDC_POSMONO, m_iPosMono);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFmQDlg, CDialog)
	//{{AFX_MSG_MAP(CFmQDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFmQDlg message handlers


BOOL CFmQDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_iPosMono = gblFmPos;
	// FASLE Update the dialog
	UpdateData(FALSE);	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFmQDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	int iPosMono;
	iTimeout=2;

	//DKFmQ(int iTimeout, BYTE *bReturn, int *iFmQ);
	iRtn=DKFmQ(iTimeout, StatusCancel, &iPosMono);	
	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	if (StatusB<=127)
	{
		gblFmPos = iPosMono;
		gblLED = iPosMono;
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
		{
			m_iPosMono = iPosMono;
			gblLED = iPosMono;
		}
	}
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
}

void CFmQDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
