// SSpeedDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "SSpeedDlg.h"

#define	__SSPEEDDLG__
#include "DllCOM.h"
#undef __SSPEEDDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSSpeedDlg dialog

extern int gblPortNo;
extern int gblSSpeed;

CSSpeedDlg::CSSpeedDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSSpeedDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSSpeedDlg)
	m_lSpeedTOut = 0;
	m_iSpeedCancel = 0;
	m_lSpeedNew = 0;
	m_iSpeedStatus = 0;
	//}}AFX_DATA_INIT
}


void CSSpeedDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSSpeedDlg)
	DDX_Text(pDX, IDC_SSPDTOUT, m_lSpeedTOut);
	DDV_MinMaxLong(pDX, m_lSpeedTOut, 0, 3599);
	DDX_Text(pDX, IDC_SSPEEDCANCEL, m_iSpeedCancel);
	DDX_Text(pDX, IDC_SSPEEDNEW, m_lSpeedNew);
	DDX_Text(pDX, IDC_SSPEEDSTATUS, m_iSpeedStatus);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSSpeedDlg, CDialog)
	//{{AFX_MSG_MAP(CSSpeedDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSSpeedDlg message handlers
extern int gblPortNo;
extern int gblSSpeed;


BOOL CSSpeedDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	m_iSpeedCancel = 0;
	m_iSpeedStatus = 0;

	m_lSpeedTOut=2;	// Initialize to 100s.
	m_lSpeedNew=gblSSpeed;
	// FALSE: Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CSSpeedDlg::OnOK() 
{
	// TODO: Add extra validation here

	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	long lSSpeed;
	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lSpeedTOut;
	lSSpeed = m_lSpeedNew;
	
	iRtn=DKSSpeed(iTimeout, StatusCancel, lSSpeed);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iSpeedStatus=StatusB;
	m_iSpeedCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		gblSSpeed = lSSpeed;
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
			gblSSpeed = lSSpeed;
	}

	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}	

	//CDialog::OnOK();
}

void CSSpeedDlg::OnCancel() 
{
	// TODO: Add extra cleanup here

	closeCOM();
	CDialog::OnCancel();
}
