// NovramRdDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DKA.h"
#include "NRdDlg.h"
//#include "abDll.h"

#define	__NRDDLG__
#include "DllCOM.h"
#undef __NRDDLG__

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNRdDlg dialog

extern int gblPortNo;


CNovramRdDlg::CNovramRdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNovramRdDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNovramRdDlg)
	m_iNRdAddress = 1;
	m_iNRdData = 0;
	m_sNRdDataHex = _T("0");
	m_lNRdTOut = 2;
	m_iNRdCancel = 0;
	m_iNRdStatus = 0;
	//}}AFX_DATA_INIT
}


void CNovramRdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNovramRdDlg)
	DDX_Control(pDX, IDCANCEL, m_cExit);
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_NRDADDRESS, m_iNRdAddress);
	DDV_MinMaxInt(pDX, m_iNRdAddress, 1, 64);
	DDX_Text(pDX, IDC_NRDDATA, m_iNRdData);
	DDV_MinMaxInt(pDX, m_iNRdData, 0, 65535);
	DDX_Text(pDX, IDC_NRDDATAHEX, m_sNRdDataHex);
	DDX_Text(pDX, IDC_NRDTOUT, m_lNRdTOut);
	DDV_MinMaxLong(pDX, m_lNRdTOut, 0, 3599);
	DDX_Text(pDX, IDC_NRDCANCEL, m_iNRdCancel);
	DDX_Text(pDX, IDC_NRDSTATUS, m_iNRdStatus);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNovramRdDlg, CDialog)
	//{{AFX_MSG_MAP(CNovramRdDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNovramRdDlg message handlers

BOOL CNovramRdDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	if(!(openCOM(gblPortNo, 9600)))
		AfxMessageBox("An Error Has Occurred When Using openCOM()!!!", MB_OK);

	//m_sNRdDataHex.Format("%04X", 255);
	//m_iNRdData=255;
	m_iNRdStatus=0; 
	m_iNRdCancel=0;
	// FALSE: Update the dialog
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CNovramRdDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	//0: no error, 1: Not echo, 2: Port not open
	BYTE StatusB, CancelB;
	BYTE StatusCancel[2];
	int iRtn, iTimeout;
	int iAddr;
	long lData;
	// Update the variable
	UpdateData(TRUE);
	iTimeout=(int)m_lNRdTOut;
	iAddr = m_iNRdAddress;
	//DKNovramRd(int iTimeout, BYTE *bReturn, long *lData, int iAddr);
	iRtn=DKNovramRd(iTimeout, StatusCancel, &lData, iAddr);	

	StatusB=StatusCancel[0];
	CancelB=StatusCancel[1];

	m_iNRdStatus=StatusB;
	m_iNRdCancel=CancelB;
	// Update dialog
	UpdateData(FALSE);

	if (StatusB<=127)
	{
		m_iNRdData=lData;
		m_sNRdDataHex.Format("%04X", lData);
	}
	else
	{
		if ( (StatusB & 64)==0)
		MessageBox("An error has occurred !",
			"Status != 128",
			MB_ICONSTOP);
		else
		{
			m_iNRdData=lData;
			m_sNRdDataHex.Format("%04X", lData);
		}
	}
	// Update dialog
	UpdateData(FALSE);
	if(StatusB==1)
	{
		MessageBox("Timeout !", "Timeout", MB_ICONSTOP);
	}
	m_cOK.EnableWindow(TRUE);
}

void CNovramRdDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	closeCOM();	
	CDialog::OnCancel();
}
